#include <iostream>
#include <vector>
#include <unordered_set>
#include <unordered_map>

using namespace std;

typedef long long ll;
typedef vector<ll> vi;

struct cls {
    unordered_set<cls*> is_a;
    unordered_set<cls*> has_a;

    bool query_is_a(cls* query) {
        if (is_a.count(query) || query == this)
            return true;

        for (auto it = is_a.begin(); it != is_a.end(); ++it) {
            if ((*it)->query_is_a(query))
                return true;
        }

        return false;
    }

    bool query_has_a(cls* query) {
        if (has_a.count(query))
            return true;

        for (auto it = is_a.begin(); it != is_a.end(); ++it) {
            if ((*it)->query_has_a(query))
                return true;
        }

        for (auto it = has_a.begin(); it != has_a.end(); ++it) {
            if ((*it)->query_has_a(query))
                return true;

            if ((*it)->query_is_a(query))
                return true;
        }

        return false;
    }
};

unordered_map<string, cls*> string_to_cls;

cls* get_class(string cls_str) {
    if (!string_to_cls.count(cls_str)) {
        string_to_cls[cls_str] = new cls();
    }

    return string_to_cls[cls_str];
}

int main() {
    ll n, m;
    cin >> n >> m;

    for (ll i = 0; i < n; ++i) {
        string c_1, r, c_2;
        cin >> c_1 >> r >> c_2;

        cls* c_1_cls = get_class(c_1);
        cls* c_2_cls = get_class(c_2);

        if (r == "is-a") {
            c_1_cls->is_a.insert(c_2_cls);
        }
        else {
            c_1_cls->has_a.insert(c_2_cls);
        }
    }

    for (ll i = 0; i < m; ++i) {
        string c_1, r, c_2;
        cin >> c_1 >> r >> c_2;

        cls* c_1_cls = get_class(c_1);
        cls* c_2_cls = get_class(c_2);

        bool success;
        if (r == "is-a") {
            success = c_1_cls->query_is_a(c_2_cls);
        }
        else {
            success = c_1_cls->query_has_a(c_2_cls);
        }

        if (success)
            cout << "Query " << i+1 << ": true" << endl;
        else
            cout << "Query " << i+1 << ": false" << endl;
    }
}
