/*
   Racing Around the Alphabet
   Ivor Page
*/
import java.io.*;
import java.util.*;

class alphabet {

    static int charToDec(char c) {
	if(c==' ')
	    return 0;
	if(c=='\'')
	    return 1;
	return c - 'A' + 2;
    }

    static int findDistance(int posn1, int posn2) {
	int fwdDistance = posn2 - posn1;
	if(fwdDistance<0)
	    fwdDistance = 28 + fwdDistance;
	int revDistance = posn1 - posn2;
	if(revDistance<0)
	    revDistance = 28 + revDistance;
	return  Math.min(fwdDistance, revDistance);
    }

    public static void main(String [] args) throws IOException {
	Scanner sc = new Scanner(System.in);

	String line = sc.nextLine();
	int num = Integer.parseInt(line);
	double spacing = 60*Math.PI/28.0; // 6.731984257692414
	double timePerSpace = spacing/15.0; // 0.448798950512828
	double pickupTime = 1.0;
	double time = 0.0;
	for(int i=0;i<num;i++) {
	    line = sc.nextLine();
	    int len = line.length();
	    int totDistance = 0;
	    for(int j=0;j<len-1;j++) {
		int posn1 = charToDec(line.charAt(j));
		int posn2 = charToDec(line.charAt(j+1));
		int distance = findDistance(posn1, posn2);
		//		System.out.println("distance = " + distance);
		totDistance += distance;
	    }
	    time = totDistance*timePerSpace + pickupTime*len;
	    System.out.printf("%.10f\n", time);
	}
    }
}
