#include <iostream>
#include <vector>
#include <cmath>

#define INF 1000000000000000000LL

using namespace std;

typedef long long ll;
typedef vector<double> vd;
typedef vector<vd> vvd;

vvd dist(28, vd(28, INF));

ll char_to_idx(char c) {
    if (c == ' ')
        return 26;
    else if (c == '\'')
        return 27;
    else
        return c - 'A';
}

int main() {
    for (ll i = 0; i < 28; ++i) {
        for (ll j = i; j < 28; ++j) {
            ll portion = min(j-i, i + 28-j);
            dist[i][j] = (portion/28.0 * M_PI * 60) / 15.0;
        }
    }

    for (ll i = 0; i < 28; ++i) {
        for (ll j = 0; j < 28; ++j) {
            dist[i][j] = min(dist[i][j], dist[j][i]);
        }
    }
    
    ll N;
    cin >> N;

    string blah;
    getline(cin, blah);

    for (ll i = 0; i < N; ++i) {
        string line;
        getline(cin, line);

        double total_d = line.size();
        for (ll j = 1; j < line.size(); ++j) {
            total_d += dist[char_to_idx(line[j])][char_to_idx(line[j-1])];
        }

        printf("%.12lf\n", total_d);
    }
}
